 ;;; make-ffi.lisp --- make FFI

 ;;; Copyright (C) 2009 by Walter C. Pelissero

 ;;; Author: Walter C. Pelissero <walter@pelissero.de>
 ;;; Project: igorplug

#+cmu (ext:file-comment "$Module: make-ffi.lisp, Time-stamp: <2009-03-15 18:01:40 wcp> $")

;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Lesser General Public License
;;; as published by the Free Software Foundation; either version 2.1
;;; of the License, or (at your option) any later version.
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Lesser General Public License for more details.
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with this library; if not, write to the Free
;;; Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
;;; 02111-1307 USA

(in-package :igor-plug)

(defun make-igorplug-ffi ()
  (let ((namespace (make-instance 'c-namespace)))
    (binge-compiler:add-declaration *gcc-builtin-va_list* namespace)
    (binge-compiler:add-declaration *gcc-builtin-va_list* namespace)
    (populate-namespace namespace
			(extract-from-headers '("igorplug.h")
					      :defines *gcc-null-defines*
					      :include-paths (list (make-pathname :defaults #.(or *compile-file-pathname*
												  *load-pathname*)
										  :name nil
										  :type nil))))
    (make-ffi *standard-output* namespace
	      :functions t
	      :backend (make-instance 'binge-backend:uffi-backend))))
